unit MainUnit;
{  !}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Preview, Menus, About, Kol, FileCtrl, KOLGZipFuncs, cases;

type
  TBMPPalette=array[0..255]of record
                                 R,G,B,F: Byte;
                               end;

  TForm1 = class(TForm)
    SaveDialog1: TSaveDialog;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Panel1: TPanel;
    Panel2: TPanel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    Panel3: TPanel;
    FilterComboBox1: TFilterComboBox;
    FileListBox1: TFileListBox;
    GroupBox1: TGroupBox;
    ListBox1: TListBox;
    ScrollBox1: TScrollBox;
    PaintBox1: TPaintBox;
    procedure PrepairSpriteBase;
    function LoadSprTree(SPRName: string): Boolean;
    function ExtractZARTIL(DATName: string): Boolean;
    procedure FormCreate(Sender: TObject);
    procedure FileListBox1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  function GetFileType(FName: string): Byte;
  procedure Expand(b: byte; var t,l: Byte);
  function Compare(Arr1,Arr2: array of char; Len: LongInt): Boolean;

const
// 
  ftNone=0;
  ftZar=1;
  ftTil=2;
  ftSpr=3;
// 
  ifNormal=1;
  ifCompressed=2;
//   " "

var
//   SPR
  TempGlobalTotalSprites,GlobalTotalSprites,CurSprite: LongInt;
  TotalNEntries: Word;         // "" 
  NEntries: array of record
                       Junk_1: array[1..2]of char; //
                       JunkBlocksNumber: LongInt;  //  
                       NameLength: LongInt;        // 
       end;
  TotalAEntries: LongInt;
  AEntries: array of record
                       id: array[1..9]of char;     //.  - <spranim>
                       Junk_1: array[1..3]of char; // (?)
                       ImageOffset: LongInt;       //    <spranim_img>
                       NameLength: LongInt;        //  
                       JL1,JL2: LongInt;           //     .  -  
                       TotalSprites: LongInt;
                       end;
  Sprites: array of PBitmap;
  ImageFormat: LongInt;             //  (SPR)
// 
  Form1: TForm1;
  fType: LongInt;                 // ;
  BuffID: array[0..7]of char;
  Buffer: array[0..799]of byte;
  ZarID: array[0..4]of char=('<','z','a','r','>');
  TilID: array[0..5]of char=('<','t','i','l','e','>');
  SprID: array[0..7]of char=('<','s','p','r','i','t','e','>');
  CurDir,CurrentSprite: string;
  TotalSprites: LongInt;
  ID: ARRAY[1..2]OF Char;
  SPRGroups: array[1..100]of string;
  SPRBase: array[1..500]of record
                             PalOffset: LongInt;
                             ZarOffset: LongInt;
                           end;
  BMPPalette: TBMPPalette;
  MemoryBMP: PBitmap;
  FullWidth,FullHeight: LongInt;
  BMPHeader: RECORD
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;     //DataSize=X*Y+2*Y
               DataSize2: LongInt;     //DataSize=X*Y+2*Y
               _C5: ARRAY[1..8]OF Byte;
             END;

implementation

uses Waiting;

{$R *.DFM}

procedure TForm1.PrepairSpriteBase;
var
  i: LongInt;
begin
  if GlobalTotalSprites=0 then Exit;
  for i:=1 to GlobalTotalSprites do Sprites[i-1].Free;
  GlobalTotalSprites:=0;
  SetLength(Sprites,GlobalTotalSprites);
end;

function Compare(Arr1,Arr2: array of char; Len: LongInt): Boolean;
var
  i: LongInt;
  Res: Boolean;
begin
  Res:=True;
  for i:=1 to Len do if not(Arr1[i-1]=Arr2[i-1]) then Res:=False;
  Result:=Res;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  ID[1]:='B';
  ID[2]:='M';
  MemoryBMP:=NewBitmap(1,1);
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  GetDir(0,CurDir);
end;

function TForm1.ExtractZARTIL(DATName: string): Boolean;
var
  FDat: PStream;
  FBmp,FTemp: PStream;
  i,j,TotalRowWidth,StartOffset: LongInt;
  Add,BB,BL,BT: Byte;
begin
  FDat:=NewReadFileStream(DATName);
  FBmp:=NewMemoryStream;
  FTemp:=NewMemoryStream;
  {***    <zar>}
  if fType=ftZar then StartOffset:=0 else
  begin
    FDat.Seek($07,spBegin);
    repeat
      FDat.Read(Buffer[0],1);
    until Buffer[0]=$00;
    FDat.Seek($13,spCurrent);
    repeat
      FDat.Read(Buffer[0],1);
    until Buffer[0]=Ord('<');
    FDat.Seek($10,spCurrent);
    StartOffset:=FDat.Position;
  end;
  {***    <zar>}
  {***   }
  FDat.Seek(StartOffset+$08,spBegin);
  FDat.Read(FullWidth,4);
  FDat.Read(FullHeight,4);
  {***   }
  {***   }
  FDat.Seek(StartOffset+$15,spBegin);
  for i:=0 to 255 do
  begin
    FDat.Read(BMPPalette[i].R,1);
    FDat.Read(BMPPalette[i].G,1);
    FDat.Read(BMPPalette[i].B,1);
    FDat.Read(BMPPalette[i].F,1);
  end;
  if fType=ftZar then
  begin
    BMPPalette[$FC].R:=$00;
    BMPPalette[$FC].G:=$00;
    BMPPalette[$FC].B:=$00;
    BMPPalette[$FC].F:=$00;
  end;
  if fType=ftZar then FDat.Seek($05,spCurrent) else FDat.Seek($04,spCurrent);
  {***   }
  {***   }
  BMPHeader.x:=FullWidth;
  BMPHeader.y:=FullHeight;
  BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
  BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
  BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
  BMPHeader._H3:=BMPHeader.FullSize-$36;
  FBmp.Write(ID,2);
  FBmp.Write(BMPHeader,SizeOf(BMPHeader));
  FBmp.Write(BMPPalette,1024);
  {***   }
  Add:=Round(Int((4*(1-(Frac(FullWidth/4))))));
  if Add=4 then Add:=0;
  {***   }
  for i:=1 to FullHeight do
  begin
    TotalRowWidth:=0;
    repeat
      FDat.Read(BB,1);
      Expand(BB,BT,BL);
      case BT of
        $0:begin
             FillChar(Buffer,BL,$00);
             FTemp.Write(Buffer,BL);
           end;
        $1:begin
             Stream2Stream(FTemp,FDat,BL);
           end;
        $2:begin
             FDat.Read(Buffer,BL*2);
             for j:=0 to BL-1 do Buffer[j]:=Buffer[J*2];
             FTemp.Write(Buffer,BL);
           end;
        $3:begin
             FDat.Read(Buffer,BL);
             FillChar(Buffer,BL,$FC);
             FTemp.Write(Buffer,BL);
           end;
      end;
      TotalRowWidth:=TotalRowWidth+BL;
    until TotalRowWidth=FullWidth;
    if Add>0 then FTemp.Write(Buffer,Add);
  end;
  {***   }
  // 
  for i:=1 to FullHeight do
  begin
    FTemp.Seek((FullHeight-i)*(FullWidth+Add),spBegin);
    Stream2Stream(FBmp,FTemp,FullWidth+Add);
  end;
  FBmp.Seek(0,spBegin);
  MemoryBMP.LoadFromStream(FBmp);
  PaintBox1.Canvas.Handle:=MemoryBMP.Handle;
  PaintBox1.Repaint;
  FBmp.Free;
  FTemp.Free;
  FDat.Free;
end;

procedure Expand(b: byte; var t,l: Byte);
begin
  t:=b and $03;
  l:=b shr 2;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  ListBox1.Items.Clear;
  fType:=GetFileType(FileListBox1.FileName);
  CurrentSprite:=FileListBox1.FileName;
  case FType of
  ftTil,ftZar: ExtractZARTIL(FileListBox1.FileName);
  ftSpr: LoadSprTree(FileListBox1.FileName);
  end;
end;

function GetFileType(FName: string): Byte;
var
  FDat: PStream;
begin
  FDat:=NewReadFileStream(FName);
  FDat.Read(BuffID,8);
  if Compare(BuffID,ZarID,5) then Result:=ftZAR else
  if Compare(BuffID,TilID,6) then Result:=ftTIL else
  if Compare(BuffID,SprID,6) then Result:=ftSPR else Result:=ftNone;
end;

function TForm1.LoadSprTree(SPRName: string): Boolean;
var
  FSpr,FBmp,FDecompressed,FTemp: PStream;
  i,j,y,x,TotalRowWidth,CompressedSize,DecompressedSize: LongInt;
  W1,W2: Word;
  TempChar: Char;
  BB,BT,BL,Add: Byte;
  CurBlock,J1,J2,J3,J4: LongInt;
begin
  FSpr:=NewReadFileStream(SPRName);
  //    "" 
  FSpr.Seek($19,spBegin);
  FSpr.Read(TotalNEntries,2);
  //  "" 
  SetLength(NEntries,TotalNEntries);
  for i:=1 to TotalNEntries do
  begin
    FSpr.Read(NEntries[i-1].Junk_1,2);
    FSpr.Read(NEntries[i-1].JunkBlocksNumber,4);
    FSpr.Seek(NEntries[i-1].JunkBlocksNumber*2+NEntries[i-1].JunkBlocksNumber*4,spCurrent);
    FSpr.Read(NEntries[i-1].NameLength,4);
    FSpr.Seek(NEntries[i-1].NameLength,spCurrent);
  end;
  //    <spranim>
  FSpr.Read(W1,2);
  FSpr.Read(W2,2);
  FSpr.Seek(2,spCurrent);
  TotalAEntries:=Max(W1,W2);
  SetLength(AEntries,TotalAEntries);
  for i:=1 to TotalAEntries do
  begin
//    
    FSpr.Seek(12,spCurrent);
//   
    FSpr.Read(AEntries[i-1].ImageOffset,4);
    FSpr.Read(AEntries[i-1].NameLength,4);
// 
    FSpr.Seek(AEntries[i-1].NameLength,spCurrent);
    FSpr.Read(AEntries[i-1].JL1,4);
    FSpr.Read(AEntries[i-1].JL2,4);
    AEntries[i-1].TotalSprites:=AEntries[i-1].JL1*AEntries[i-1].JL2;
    TempGlobalTotalSprites:=0;
    for j:=1 to AEntries[i-1].TotalSprites do
    begin
      FSpr.Read(J1,4);
      FSpr.Read(J2,4);
      FSpr.Read(J3,4);
      FSpr.Read(J4,4);
      if (J1<>0)or(J2<>0)or(J3<>0)or(J4<>0) then Inc(TempGlobalTotalSprites);
    end;
    AEntries[i-1].TotalSprites:=TempGlobalTotalSprites;
//   
  end;
//   
  PrepairSpriteBase;
  GlobalTotalSprites:=0;
  for i:=1 to TotalAEntries do GlobalTotalSprites:=GlobalTotalSprites+AEntries[i-1].TotalSprites;
  SetLength(Sprites,GlobalTotalSprites);
{******************************************************************
            <spranim_img>
******************************************************************}
  Form2.Show;
  Form2.Refresh;
  ListBox1.Items.Clear;
  CurSprite:=0;
  CurBlock:=0;
  Form2.StaticText2.Caption:=Int2Str(GlobalTotalSprites);
//   
  for i:=1 to TotalAEntries do
  begin
    FSpr.Seek(AEntries[i-1].ImageOffset,spBegin);
//  
    FSpr.Seek($0E,spCurrent);
    FSpr.Read(TempChar,1);
    if TempChar='1' then ImageFormat:=ifNormal else
    if TempChar='2' then ImageFormat:=ifCompressed else
    begin
      ShowMessage('  !');
      Halt;
    end;
    //   
    if ImageFormat=ifNormal then
    begin
      FSpr.Seek(5,spCurrent);
      // 
      for j:=0 to 255 do
      begin
        FSpr.Read(BMPPalette[j].R,1);
        FSpr.Read(BMPPalette[j].G,1);
        FSpr.Read(BMPPalette[j].B,1);
        FSpr.Read(BMPPalette[j].F,1);
      end;
      //  ( -) 
      FSpr.Seek(3*(4+$400),spCurrent);
      for j:=1 to AEntries[i-1].TotalSprites do
      begin
        FBmp:=NewMemoryStream;
        FTemp:=NewMemoryStream;
//   Zar
        FSpr.Seek(9,spCurrent);
//  
        FSpr.Seek(8,spCurrent);
        FSpr.Read(FullWidth,4);
        FSpr.Read(FullHeight,4);
//  
        Add:=Round(Int((4*(1-(Frac(FullWidth/4))))));
        if Add=4 then Add:=0;
// 
        BMPHeader.x:=FullWidth;
        BMPHeader.y:=FullHeight;
        BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
        BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
        BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
        BMPHeader._H3:=BMPHeader.FullSize-$36;
        FBmp.Write(ID,2);
        FBmp.Write(BMPHeader,SizeOf(BMPHeader));
        FBmp.Write(BMPPalette,1024);
//   
        FSpr.Seek(5,spCurrent);
// 
        for y:=1 to FullHeight do
        begin
          TotalRowWidth:=0;
          repeat
            FSpr.Read(BB,1);
            Expand(BB,BT,BL);
            case BT of
            $0:begin
                 FillChar(Buffer,BL,$00);
                 FTemp.Write(Buffer,BL);
               end;
            $1:begin
                 Stream2Stream(FTemp,FSpr,BL);
               end;
            $2:begin
                 FSpr.Read(Buffer,BL*2);
                 for x:=0 to BL-1 do Buffer[x]:=Buffer[x*2];
                 FTemp.Write(Buffer,BL);
               end;
            $3:begin
                 FSpr.Read(Buffer,BL);
                 FillChar(Buffer,BL,$00);
                 FTemp.Write(Buffer,BL);
               end;
            end;
            TotalRowWidth:=TotalRowWidth+BL;
          until TotalRowWidth=FullWidth;
          if Add>0 then FTemp.Write(Buffer,Add);
        end;
        FTemp.Seek(0,spBegin);
        for y:=1 to FullHeight do
        begin
          FTemp.Seek((FullHeight-y)*(FullWidth+Add),spBegin);
          Stream2Stream(FBmp,FTemp,FullWidth+Add);
        end;
        FBmp.Seek(0,spBegin);
        Sprites[CurSprite]:=NewBitmap(1,1);
        Sprites[CurSprite].LoadFromStream(FBmp);
        ListBox1.Items.Add(' '+Int2Str(CurSprite));
        Inc(CurSprite);
        FBmp.Free;
        FTemp.Free;
//   3    Zar
        FSpr.Seek(3,spCurrent);
      end;
    end;
//   
    if ImageFormat=ifCompressed then
    begin
      FSpr.Seek(1,spCurrent);
      FSpr.Read(DecompressedSize,4);
      FDecompressed:=NewMemoryStream;
      if i<TotalAEntries then CompressedSize:=AEntries[i].ImageOffset-AEntries[i-1].ImageOffset-20 else CompressedSize:=FSpr.Size-AEntries[i-1].ImageOffset-20;
      DecompressStreamToStream(FSpr,compressedSize,DeCompressedSize,FDecompressed);
      FDecompressed.Seek($04,spBegin);
      // 
      for j:=0 to 255 do
      begin
        FDecompressed.Read(BMPPalette[j].R,1);
        FDecompressed.Read(BMPPalette[j].G,1);
        FDecompressed.Read(BMPPalette[j].B,1);
        FDecompressed.Read(BMPPalette[j].F,1);
      end;
      FDecompressed.Seek(3*(4+$400),spCurrent);
      //  ( -) 
      CurBlock:=0;
      for j:=1 to AEntries[i-1].TotalSprites do
      begin
        FBmp:=NewMemoryStream;
        FTemp:=NewMemoryStream;
//   Zar
        repeat
          FDecompressed.Read(TempChar,1);
        until (TempChar='<');
//  
        FDecompressed.Seek(7,spCurrent);
        FDecompressed.Read(FullWidth,4);
        FDecompressed.Read(FullHeight,4);
//  
        Add:=Round(Int((4*(1-(Frac(FullWidth/4))))));
        if Add=4 then Add:=0;
// 
        BMPHeader.x:=FullWidth;
        BMPHeader.y:=FullHeight;
        BMPheader.DataSize1:=BMPHeader.x*BMPHeader.y;
        BMPheader.DataSize2:=BMPHeader.x*BMPHeader.y;
        BMPHeader.FullSize:=BMPHeader.DataSize1+$436;
        BMPHeader._H3:=BMPHeader.FullSize-$36;
        FBmp.Write(ID,2);
        FBmp.Write(BMPHeader,SizeOf(BMPHeader));
        FBmp.Write(BMPPalette,1024);
//   
        FDecompressed.Seek(5,spCurrent);
// 
        for y:=1 to FullHeight do
        begin
          TotalRowWidth:=0;
          repeat
            FDecompressed.Read(BB,1);
            Expand(BB,BT,BL);
            case BT of
            $0:begin
                 FillChar(Buffer,BL,$00);
                 FTemp.Write(Buffer,BL);
               end;
            $1:begin
                 Stream2Stream(FTemp,FDecompressed,BL);
               end;
            $2:begin
                 FDecompressed.Read(Buffer,BL*2);
                 for x:=0 to BL-1 do Buffer[x]:=Buffer[x*2];
                 FTemp.Write(Buffer,BL);
               end;
            $3:begin
                 FDecompressed.Read(Buffer,BL);
                 FillChar(Buffer,BL,$00);
                 FTemp.Write(Buffer,BL);
               end;
            end;
            TotalRowWidth:=TotalRowWidth+BL;
          until TotalRowWidth=FullWidth;
          if Add>0 then FTemp.Write(Buffer,Add);
        end;
        for y:=1 to FullHeight do
        begin
          FTemp.Seek((FullHeight-y)*(FullWidth+Add),spBegin);
          Stream2Stream(FBmp,FTemp,FullWidth+Add);
        end;
        FBmp.Seek(0,spBegin);
        Sprites[CurSprite]:=NewBitmap(1,1);
        Sprites[CurSprite].LoadFromStream(FBmp);
        ListBox1.Items.Add(' '+Int2Str(CurSprite));
        Inc(CurSprite);
        Form2.StaticText1.Caption:=Int2Str(CurSprite);
        FBmp.Free;
        FTemp.Free;
//   3    Zar
      end;
      FDecompressed.Free;
      Inc(CurBlock);
    end;
  end;
  FSpr.Free;
  Form2.Hide;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  Form3.ShowModal;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  MemoryBMP.Draw(PaintBox1.Canvas.Handle,0,0);
  PaintBox1.Width:=MemoryBMP.Width;
  PaintBox1.Height:=MemoryBMP.Height;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  if ListBox1.ItemIndex=-1 then Exit;
  if GlobalTotalSprites=0 then Exit;
  if ListBox1.ItemIndex>GlobalTotalSprites-1 then Exit;
  MemoryBMP:=Sprites[ListBox1.ItemIndex];
  PaintBox1.Canvas.Handle:=MemoryBMP.Handle;
  PaintBox1.Repaint;
end;

procedure TForm1.PaintBox1Click(Sender: TObject);
var
  FName: string;
begin
  FName:=ExtractFileName(FileListBox1.FileName);
  FName:=Copy(FName,1,Pos('.',FName)-1);
  SaveDialog1.FileName:=CurDir+'\'+FName+BuildStr(Int2Str(ListBox1.ItemIndex),'0',3);
  if SaveDialog1.Execute then MemoryBMP.SaveToFile(SaveDialog1.FileName);
  CurDir:=ExtractFilePath(SaveDialog1.FileName);
  CurDir:=Copy(CurDir,1,Length(CurDir)-1);
end;

end.
